package ch.ivyteam.test;

import ch.ivyteam.ivy.environment.Ivy;
import ch.ivyteam.ivy.server.ServerFactory;
import ch.ivyteam.ivy.workflow.ICase;
import ch.ivyteam.ivy.workflow.IWorkflowEvent;
import ch.ivyteam.ivy.workflow.IWorkflowManager;
import ch.ivyteam.ivy.workflow.WorkflowChangeEvent;
import ch.ivyteam.ivy.workflow.WorkflowChangeEventKind;
import ch.ivyteam.ivy.workflow.WorkflowEventKind;

public class CaseCreatedListener implements ch.ivyteam.ivy.workflow.IWorkflowListener{
	public static void register(){
		IWorkflowManager workflowManager = ServerFactory.getServer().getManager(IWorkflowManager.class);
		workflowManager.addWorkflowListener(new CaseCreatedListener(workflowManager));
	}
	
	private IWorkflowManager wfManager;

	private CaseCreatedListener(IWorkflowManager wfManager){
		this.wfManager = wfManager;
	}
	
	@Override
	public void workflowChanged(WorkflowChangeEvent event) {
		if (event.getEventKind() != WorkflowChangeEventKind.CREATED){
			return;
		}
		
		IWorkflowEvent createEvent = wfManager.findWorkflowEvent(event.getId());
		if (createEvent.getEventKind() != WorkflowEventKind.EVENT_CREATE_CASE){
			return;
		}
		
		ICase newCase = createEvent.getCase();
		Ivy.log().info("new case created: "+newCase);
	}
	
}
